FUNCTION parser
PARAMETER str,width,textw,mautofit
PRIVATE flds,i,j,K,x,y,z,siz,givtot,autofit
PRIVATE calcpresent,siz,bsize,calctot,temptot,retval
DIMENSION flds(1,6)
IF EMPTY(str)
	str=buildstr()
ENDIF
IF mautofit="OFF"
	return "FIELDS "+str
ENDIF

i=0
givtot=0
autofit=.F.
calcpresent=.F.
DO WHILE !EMPTY(str)
	i=i+1
	DIMENSION flds(i,6)
	flds(i,6)=1
	IF ","$str
		flds(i,1)=LEFT(str,AT(',',str)-1)
		str=SUBSTR(str,AT(',',str)+1)
	ELSE
		flds(i,1)=str
		str=""
	ENDIF
	IF ":R:"$STRTRAN(flds(i,1)," ","")
		j=AT(":",flds(i,1),2)
		K=AT(":",flds(i,1),3)
	ELSE
		j=AT(":",flds(i,1),1)
		K=AT(":",flds(i,1),2)
	ENDIF
	IF K=0
		K=LEN(flds(i,1))+1
	ENDIF
	flds(i,3)=j+1
	flds(i,4)=K-j-1
	flds(i,2)=SUBSTR(flds(i,1),j+1,K-j-1)
	flds(i,5)=0
	** determine its data type:
	x=AT("=",flds(i,1))+1
	y=AT(":",flds(i,1))
	IF y<0
		y=LEN(flds(i,1))
	ENDIF
	IF x<y
		y=y-x
		z=EVAL(SUBSTR(flds(i,1),x,y))
		IF INLIST(TYPE("z"),"N","D")
			flds(i,6)=textw
		ENDIF
	ENDIF

	IF !(VAL(flds(i,2))>0 OR "*"$flds(i,2))
		IF "="$flds(i,1) AND ((AT("=",flds(i,1))<AT(":",flds(i,1)) AND AT(":",flds(i,1))>0) OR AT(":",flds(i,1))=0))
			** calculated field
			flds(i,2)="15"	&& give it a default if no value given
		ELSE
			flds(i,2)=""
		ENDIF
		flds(i,3)=0
		flds(i,4)=0
	ENDIF
	autofit="*"$flds(i,2) OR autofit
ENDDO
FOR j=1 TO AFIELDS(siz)
	FOR K=1 TO i
		IF UPPER(siz(j,1))=UPPER(LEFT(flds(K,1),IIF(":"$flds(K,1),AT(":",flds(K,1))-1,LEN(flds(K,1))))) 	&& this is the field
			flds(K,5)=siz(j,3)
			IF INLIST(siz(j,2),"N","D")
				flds(K,6)=textw	&& if numeric, use txtwidth factor
			ENDIF
			EXIT
		ENDIF
	ENDFOR
ENDFOR
RELEASE siz
bsize=0
calctot=0
temptot=0
FOR j=1 TO i
	bsize=bsize+flds(j,6)*IIF("*"$flds(j,2) OR (!autofit AND EMPTY(flds(j,2))),flds(j,5),VAL(flds(j,2)))
	IF autofit AND EMPTY(flds(j,2))
		flds(j,2)=STR(INT(flds(j,5)))
		temptot=temptot+flds(j,5)*flds(j,6)
	ENDIF
ENDFOR
CLEAR
FOR j=1 TO i
	IF "*"$flds(j,2) OR (!autofit AND EMPTY(flds(j,2)))
		flds(j,2)=FLOOR((m.width-(i-1)-temptot)*flds(j,5)/bsize)
		flds(j,5)="*"
	ELSE
		flds(j,2)=VAL(flds(j,2))
		flds(j,5)="0"
	ENDIF
	calctot=calctot+flds(j,2)*flds(j,6)
ENDFOR
j=1
DO WHILE CEILING(calctot)<(m.width-(i-1))
	IF ((!autofit) OR flds(j,5)="*") AND flds(j,5)<>"0"
		flds(j,2)=flds(j,2)+1
		calctot=calctot+1*flds(j,6)
	ENDIF
	j=j+1
	IF j>i
		j=1
	ENDIF
ENDDO

retval="FIELDS "
FOR j=1 TO i
	flds(j,2)=ALLTRIM(STR(flds(j,2)))
	IF flds(j,3)>0
		flds(j,1)=STUFF(flds(j,1),flds(j,3),flds(j,4),flds(j,2))
	ELSE
		IF ":R:"$STRTRAN(flds(i,1)," ","")
			K=AT(":",flds(j,1),2)
		ELSE
			K=AT(":",flds(j,1),1)
		ENDIF
		IF K=0
			K=LEN(flds(j,1))+1
		ELSE
		ENDIF
		flds(j,1)=STUFF(flds(j,1),K,0,":"+flds(j,2))
	ENDIF
	retval=retval+flds(j,1)+","
ENDFOR
retval=LEFT(retval,LEN(retval)-1)
RETURN retval

FUNCTION buildstr
PRIVATE flds,i,str
str=""
FOR i=1 to AFIELDS(flds)
	str=str+LOWER(flds(i,1))+","
ENDFOR
str=left(str,len(str)-1)
return str